---
title: Get rules for a deployment gate
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Deployment Gates
---

# Get rules for a deployment gate{% #get-rules-for-a-deployment-gate %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in preview and may be subject to change. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                                              |
| ----------------- | ------------------------------------------------------------------------- |
| ap1.datadoghq.com | GET https://api.ap1.datadoghq.com/api/v2/deployment_gates/{gate_id}/rules |
| ap2.datadoghq.com | GET https://api.ap2.datadoghq.com/api/v2/deployment_gates/{gate_id}/rules |
| app.datadoghq.eu  | GET https://api.datadoghq.eu/api/v2/deployment_gates/{gate_id}/rules      |
| app.ddog-gov.com  | GET https://api.ddog-gov.com/api/v2/deployment_gates/{gate_id}/rules      |
| us2.ddog-gov.com  | GET https://api.us2.ddog-gov.com/api/v2/deployment_gates/{gate_id}/rules  |
| app.datadoghq.com | GET https://api.datadoghq.com/api/v2/deployment_gates/{gate_id}/rules     |
| us3.datadoghq.com | GET https://api.us3.datadoghq.com/api/v2/deployment_gates/{gate_id}/rules |
| us5.datadoghq.com | GET https://api.us5.datadoghq.com/api/v2/deployment_gates/{gate_id}/rules |

### Overview

Endpoint to get rules for a deployment gate. This endpoint requires the `deployment_gates_read` permission.

### Arguments

#### Path Parameters

| Name                      | Type   | Description                    |
| ------------------------- | ------ | ------------------------------ |
| gate_id [*required*] | string | The ID of the deployment gate. |

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
Response for a deployment gate rules.

| Parent field | Field                        | Type          | Description                                                                                              |
| ------------ | ---------------------------- | ------------- | -------------------------------------------------------------------------------------------------------- |
|              | data                         | object        | Data for a list of deployment rules.                                                                     |
| data         | attributes [*required*] | object        | Attributes of the response for listing deployment rules.                                                 |
| attributes   | rules                        | [object]      | The list of deployment rules.                                                                            |
| rules        | created_at [*required*] | date-time     | The timestamp when the deployment rule was created.                                                      |
| rules        | created_by [*required*] | object        | Information about the user who created the deployment rule.                                              |
| created_by   | handle                       | string        | The handle of the user who created the deployment rule.                                                  |
| created_by   | id [*required*]         | string        | The ID of the user who created the deployment rule.                                                      |
| created_by   | name                         | string        | The name of the user who created the deployment rule.                                                    |
| rules        | dry_run [*required*]    | boolean       | Whether this rule is run in dry-run mode.                                                                |
| rules        | gate_id [*required*]    | string        | The ID of the deployment gate.                                                                           |
| rules        | name [*required*]       | string        | The name of the deployment rule.                                                                         |
| rules        | options [*required*]    |  <oneOf> | Options for deployment rule response representing either faulty deployment detection or monitor options. |
| options      | Option 1                     | object        | Faulty deployment detection options for deployment rules.                                                |
| Option 1     | duration                     | int64         | The duration for faulty deployment detection.                                                            |
| Option 1     | excluded_resources           | [string]      | Resources to exclude from faulty deployment detection.                                                   |
| options      | Option 2                     | object        | Monitor options for deployment rules.                                                                    |
| Option 2     | duration                     | int64         | Seconds the monitor needs to stay in OK status for the rule to pass.                                     |
| Option 2     | query [*required*]      | string        | Monitors that match this query are evaluated.                                                            |
| rules        | type [*required*]       | enum          | The type of the deployment rule. Allowed enum values: `faulty_deployment_detection,monitor`              |
| rules        | updated_at                   | date-time     | The timestamp when the deployment rule was last updated.                                                 |
| rules        | updated_by                   | object        | Information about the user who updated the deployment rule.                                              |
| updated_by   | handle                       | string        | The handle of the user who updated the deployment rule.                                                  |
| updated_by   | id [*required*]         | string        | The ID of the user who updated the deployment rule.                                                      |
| updated_by   | name                         | string        | The name of the user who updated the deployment rule.                                                    |
| data         | id [*required*]         | string        | Unique identifier of the deployment rule.                                                                |
| data         | type [*required*]       | enum          | List deployment rule resource type. Allowed enum values: `list_deployment_rules`                         |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "rules": [
        {
          "created_at": "2021-01-01T00:00:00Z",
          "created_by": {
            "handle": "test-user",
            "id": "1111-2222-3333-4444-555566667777",
            "name": "Test User"
          },
          "dry_run": false,
          "gate_id": "1111-2222-3333-4444-555566667777",
          "name": "My deployment rule",
          "options": {
            "duration": 3600,
            "excluded_resources": [
              "resource1",
              "resource2"
            ]
          },
          "type": "faulty_deployment_detection",
          "updated_at": "2019-09-19T10:00:00.000Z",
          "updated_by": {
            "handle": "test-user",
            "id": "1111-2222-3333-4444-555566667777",
            "name": "Test User"
          }
        }
      ]
    },
    "id": "1111-2222-3333-4444-555566667777",
    "type": "list_deployment_rules"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad request.
{% tab title="Model" %}
Bad request.

| Parent field | Field  | Type     | Description        |
| ------------ | ------ | -------- | ------------------ |
|              | errors | [object] | Structured errors. |
| errors       | detail | string   | Error message.     |
| errors       | status | string   | Error code.        |
| errors       | title  | string   | Error title.       |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Malformed payload",
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="401" %}
Unauthorized
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="500" %}
Internal Server Error
{% tab title="Model" %}
Errors occurred.

| Parent field | Field  | Type     | Description        |
| ------------ | ------ | -------- | ------------------ |
|              | errors | [object] | Structured errors. |
| errors       | detail | string   | Error message.     |
| errors       | status | string   | Error code.        |
| errors       | title  | string   | Error title.       |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Malformed payload",
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \# Path parameters export gate_id="CHANGE_ME" \# Curl command curl -X GET "https://api.datadoghq.com/api/v2/deployment_gates/${gate_id}/rules" \
-H "Accept: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" 
                
##### 

```python
"""
Get rules for a deployment gate returns "OK" response
"""

from os import environ
from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.deployment_gates_api import DeploymentGatesApi

# there is a valid "deployment_gate" in the system
DEPLOYMENT_GATE_DATA_ID = environ["DEPLOYMENT_GATE_DATA_ID"]

configuration = Configuration()
configuration.unstable_operations["get_deployment_gate_rules"] = True
with ApiClient(configuration) as api_client:
    api_instance = DeploymentGatesApi(api_client)
    response = api_instance.get_deployment_gate_rules(
        gate_id=DEPLOYMENT_GATE_DATA_ID,
    )

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Get rules for a deployment gate returns "OK" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.get_deployment_gate_rules".to_sym] = true
end
api_instance = DatadogAPIClient::V2::DeploymentGatesAPI.new

# there is a valid "deployment_gate" in the system
DEPLOYMENT_GATE_DATA_ID = ENV["DEPLOYMENT_GATE_DATA_ID"]
p api_instance.get_deployment_gate_rules(DEPLOYMENT_GATE_DATA_ID)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```go
// Get rules for a deployment gate returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	// there is a valid "deployment_gate" in the system
	DeploymentGateDataID := os.Getenv("DEPLOYMENT_GATE_DATA_ID")

	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.GetDeploymentGateRules", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewDeploymentGatesApi(apiClient)
	resp, r, err := api.GetDeploymentGateRules(ctx, DeploymentGateDataID)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `DeploymentGatesApi.GetDeploymentGateRules`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `DeploymentGatesApi.GetDeploymentGateRules`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Get rules for a deployment gate returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.DeploymentGatesApi;
import com.datadog.api.client.v2.model.DeploymentGateRulesResponse;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.getDeploymentGateRules", true);
    DeploymentGatesApi apiInstance = new DeploymentGatesApi(defaultClient);

    // there is a valid "deployment_gate" in the system
    String DEPLOYMENT_GATE_DATA_ID = System.getenv("DEPLOYMENT_GATE_DATA_ID");

    try {
      DeploymentGateRulesResponse result =
          apiInstance.getDeploymentGateRules(DEPLOYMENT_GATE_DATA_ID);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DeploymentGatesApi#getDeploymentGateRules");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```rust
// Get rules for a deployment gate returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_deployment_gates::DeploymentGatesAPI;

#[tokio::main]
async fn main() {
    // there is a valid "deployment_gate" in the system
    let deployment_gate_data_id = std::env::var("DEPLOYMENT_GATE_DATA_ID").unwrap();
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.GetDeploymentGateRules", true);
    let api = DeploymentGatesAPI::with_config(configuration);
    let resp = api
        .get_deployment_gate_rules(deployment_gate_data_id.clone())
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Get rules for a deployment gate returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.getDeploymentGateRules"] = true;
const apiInstance = new v2.DeploymentGatesApi(configuration);

// there is a valid "deployment_gate" in the system
const DEPLOYMENT_GATE_DATA_ID = process.env.DEPLOYMENT_GATE_DATA_ID as string;

const params: v2.DeploymentGatesApiGetDeploymentGateRulesRequest = {
  gateId: DEPLOYMENT_GATE_DATA_ID,
};

apiInstance
  .getDeploymentGateRules(params)
  .then((data: v2.DeploymentGateRulesResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
